<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>VecNorm</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="VecNorm"><H1>VecNorm</H1></A>
Computes the vector norm. 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscvec.h" 
PetscErrorCode  VecNorm(Vec x,NormType type,PetscReal *val)  
</PRE>
Collective on <A HREF="../Vec/Vec.html#Vec">Vec</A>
<P>
<H3><FONT COLOR="#CC3333">Input Parameters</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>x </B></TD><TD>- the vector
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>type </B></TD><TD>- one of <A HREF="../Vec/NORM_1.html#NORM_1">NORM_1</A>, <A HREF="../Vec/NORM_2.html#NORM_2">NORM_2</A>, <A HREF="../Vec/NORM_INFINITY.html#NORM_INFINITY">NORM_INFINITY</A>.  Also available
<A HREF="../Vec/NORM_1_AND_2.html#NORM_1_AND_2">NORM_1_AND_2</A>, which computes both norms and stores them
in a two element array.
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Output Parameter</FONT></H3>
<DT><B>val </B> -the norm 
<br>
<P>
<H3><FONT COLOR="#CC3333">C++ variants</FONT></H3><TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD> PetscReal VecNorm(Vec x)<TD WIDTH=20></TD><TD>-></TD><TD WIDTH=20></TD><TD>VecNorm(x,NORM_2,&r); return r;</TR></TD>

<TR><TD WIDTH=40></TD><TD> PetscReal VecNorm(Vec x,NormType t)<TD WIDTH=20></TD><TD>-></TD><TD WIDTH=20></TD><TD>VecNorm(x,t,&r); return r;</TR></TD>

<TR><TD WIDTH=40></TD><TD>&nbsp VecNorm(Vec x,PetscReal *r)<TD WIDTH=20></TD><TD>-></TD><TD WIDTH=20></TD><TD>VecNorm(x,NORM_2,r)</TR></TD>

</TABLE>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
<pre>
    <A HREF="../Vec/NORM_1.html#NORM_1">NORM_1</A> denotes sum_i |x_i|
</pre>
<pre>
    <A HREF="../Vec/NORM_2.html#NORM_2">NORM_2</A> denotes sqrt(sum_i (x_i)^2)
</pre>
<pre>
    <A HREF="../Vec/NORM_INFINITY.html#NORM_INFINITY">NORM_INFINITY</A> denotes max_i |x_i|
</pre>
<P>

<P>
<H3><FONT COLOR="#CC3333">Performance Issues</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>per</B></TD><TD>- processor memory bandwidth
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>interprocessor latency</B></TD><TD>- -    work load inbalance that causes certain processes to arrive much earlier than
others
</TD></TR>
<P>
<H3><FONT COLOR="#CC3333">Compile Option</FONT></H3>
PETSC_HAVE_SLOW_BLAS_NORM2 will cause a C (loop unrolled) version of the norm to be used, rather
than the BLAS. This should probably only be used when one is using the FORTRAN BLAS routines
(as opposed to vendor provided) because the FORTRAN BLAS NRM2() routine is very slow.
<P>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../Vec/VecDot.html#VecDot">VecDot</A>(), <A HREF="../Vec/VecTDot.html#VecTDot">VecTDot</A>(), <A HREF="../Vec/VecNorm.html#VecNorm">VecNorm</A>(), <A HREF="../Vec/VecDotBegin.html#VecDotBegin">VecDotBegin</A>(), <A HREF="../Vec/VecDotEnd.html#VecDotEnd">VecDotEnd</A>(), 
<BR><A HREF="../Vec/VecNormBegin.html#VecNormBegin">VecNormBegin</A>(), <A HREF="../Vec/VecNormEnd.html#VecNormEnd">VecNormEnd</A>()
<P>
<P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>intermediate
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/vec/vec/interface/rvector.c.html#VecNorm">src/vec/vec/interface/rvector.c</A>
<BR><A HREF="./index.html">Index of all Vec routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
<P><H3><FONT COLOR="#CC3333">Examples</FONT></H3>
<A HREF="../../../src/vec/vec/examples/tutorials/ex1.c.html">src/vec/vec/examples/tutorials/ex1.c.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex1e.c.html">src/vec/vec/examples/tutorials/ex1e.c.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex11.c.html">src/vec/vec/examples/tutorials/ex11.c.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex17.c.html">src/vec/vec/examples/tutorials/ex17.c.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex1f.F.html">src/vec/vec/examples/tutorials/ex1f.F.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex1f90.F.html">src/vec/vec/examples/tutorials/ex1f90.F.html</A><BR>
<A HREF="../../../src/vec/vec/examples/tutorials/ex11f.F.html">src/vec/vec/examples/tutorials/ex11f.F.html</A><BR>
<A HREF="../../../src/mat/examples/tutorials/ex2.c.html">src/mat/examples/tutorials/ex2.c.html</A><BR>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex1.c.html">src/ksp/ksp/examples/tutorials/ex1.c.html</A><BR>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex2.c.html">src/ksp/ksp/examples/tutorials/ex2.c.html</A><BR>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex3.c.html">src/ksp/ksp/examples/tutorials/ex3.c.html</A><BR>
</BODY></HTML>
